diff --git a/Changelog b/Changelog
index 92780c9953..83bc36297a 100644
--- a/Changelog
+++ b/Changelog
@@ -7,6 +7,7 @@ version <next>:
 - ffmpeg -shortest_buf_duration option
 - ffmpeg now requires threading to be built
 - ffmpeg now runs every muxer in a separate thread
+- WBMP (Wireless Application Protocol Bitmap) image format
 
 
 version 5.1:
diff --git a/doc/general_contents.texi b/doc/general_contents.texi
index f25c784d3b..86ec6d606b 100644
--- a/doc/general_contents.texi
+++ b/doc/general_contents.texi
@@ -801,6 +801,8 @@ following image formats are supported:
     @tab Targa (.TGA) image format
 @item VBN  @tab X @tab X
     @tab Vizrt Binary Image format
+@item WBMP         @tab X @tab X
+    @tab Wireless Application Protocol Bitmap image format
 @item WebP         @tab E @tab X
     @tab WebP image format, encoding supported through external library libwebp
 @item XBM  @tab X @tab X
diff --git a/libavcodec/Makefile b/libavcodec/Makefile
index a4fab108d6..9971334a7c 100644
--- a/libavcodec/Makefile
+++ b/libavcodec/Makefile
@@ -762,6 +762,8 @@ OBJS-$(CONFIG_VP9_V4L2M2M_DECODER)     += v4l2_m2m_dec.o
 OBJS-$(CONFIG_VQA_DECODER)             += vqavideo.o
 OBJS-$(CONFIG_WAVPACK_DECODER)         += wavpack.o wavpackdata.o dsd.o
 OBJS-$(CONFIG_WAVPACK_ENCODER)         += wavpackdata.o wavpackenc.o
+OBJS-$(CONFIG_WBMP_DECODER)            += wbmpdec.o
+OBJS-$(CONFIG_WBMP_ENCODER)            += wbmpenc.o
 OBJS-$(CONFIG_WCMV_DECODER)            += wcmv.o
 OBJS-$(CONFIG_WEBP_DECODER)            += webp.o
 OBJS-$(CONFIG_WEBVTT_DECODER)          += webvttdec.o ass.o
diff --git a/libavcodec/allcodecs.c b/libavcodec/allcodecs.c
index 31d2c5979c..c94e2d5966 100644
--- a/libavcodec/allcodecs.c
+++ b/libavcodec/allcodecs.c
@@ -378,6 +378,8 @@ extern const FFCodec ff_vp9_decoder;
 extern const FFCodec ff_vp9_rkmpp_decoder;
 extern const FFCodec ff_vp9_v4l2m2m_decoder;
 extern const FFCodec ff_vqa_decoder;
+extern const FFCodec ff_wbmp_decoder;
+extern const FFCodec ff_wbmp_encoder;
 extern const FFCodec ff_webp_decoder;
 extern const FFCodec ff_wcmv_decoder;
 extern const FFCodec ff_wrapped_avframe_encoder;
diff --git a/libavcodec/codec_desc.c b/libavcodec/codec_desc.c
index fdcf8198fe..c1a177c22d 100644
--- a/libavcodec/codec_desc.c
+++ b/libavcodec/codec_desc.c
@@ -1900,6 +1900,13 @@ static const AVCodecDescriptor codec_descriptors[] = {
         .long_name = NULL_IF_CONFIG_SMALL("HDR (Radiance RGBE format) image"),
         .props     = AV_CODEC_PROP_INTRA_ONLY | AV_CODEC_PROP_LOSSY,
     },
+    {
+        .id        = AV_CODEC_ID_WBMP,
+        .type      = AVMEDIA_TYPE_VIDEO,
+        .name      = "wbmp",
+        .long_name = NULL_IF_CONFIG_SMALL("WBMP (Wireless Application Protocol Bitmap) image"),
+        .props     = AV_CODEC_PROP_INTRA_ONLY | AV_CODEC_PROP_LOSSLESS,
+    },
 
     /* various PCM "codecs" */
     {
diff --git a/libavcodec/codec_id.h b/libavcodec/codec_id.h
index 27bf68ec1d..386a00a7ef 100644
--- a/libavcodec/codec_id.h
+++ b/libavcodec/codec_id.h
@@ -313,6 +313,7 @@ enum AVCodecID {
     AV_CODEC_ID_QOI,
     AV_CODEC_ID_PHM,
     AV_CODEC_ID_RADIANCE_HDR,
+    AV_CODEC_ID_WBMP,
 
     /* various PCM "codecs" */
     AV_CODEC_ID_FIRST_AUDIO = 0x10000,     ///< A dummy id pointing at the start of audio codecs
diff --git a/libavcodec/wbmpdec.c b/libavcodec/wbmpdec.c
new file mode 100644
index 0000000000..e84d5cc73c
--- /dev/null
+++ b/libavcodec/wbmpdec.c
@@ -0,0 +1,92 @@
+/*
+ * WBMP (Wireless Application Protocol Bitmap) image
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "avcodec.h"
+#include "bytestream.h"
+#include "codec_internal.h"
+#include "internal.h"
+#include "thread.h"
+
+static unsigned int getv(GetByteContext * gb)
+{
+    int i;
+    unsigned int v = 0;
+
+    do {
+        i = bytestream2_get_byte(gb);
+        v = (v << 7) | (i & 0x7F);
+    } while (i & 0x80);
+    return v;
+}
+
+static void readbits(uint8_t * dst, int width, int height, int linesize, const uint8_t * src, int size)
+{
+    int wpad = (width + 7) / 8;
+    for (int j = 0; j < height && size > 0; j++) {
+        memcpy(dst, src, FFMIN(wpad, size));
+        src += wpad;
+        size -= wpad;
+        dst += linesize;
+    }
+}
+
+static int wbmp_decode_frame(AVCodecContext *avctx, AVFrame *p,
+                            int *got_frame, AVPacket *avpkt)
+{
+    const uint8_t *buf = avpkt->data;
+    int buf_size = avpkt->size, width, height, ret;
+    GetByteContext gb;
+
+    bytestream2_init(&gb, buf, buf_size);
+
+    if (getv(&gb))
+        return AVERROR_INVALIDDATA;
+    bytestream2_skip(&gb, 1);
+    width = getv(&gb);
+    height = getv(&gb);
+
+    if ((ret = ff_set_dimensions(avctx, width, height)) < 0)
+        return ret;
+
+    avctx->pix_fmt = AV_PIX_FMT_MONOBLACK;
+    if ((ret = ff_thread_get_buffer(avctx, p, 0)) < 0)
+        return ret;
+ 
+    if (p->linesize[0] == (width + 7) / 8)
+        bytestream2_get_buffer(&gb, p->data[0], height * ((width + 7) / 8));
+    else
+        readbits(p->data[0], width, height, p->linesize[0], gb.buffer, gb.buffer_end - gb.buffer_start);
+
+    p->key_frame = 1;
+    p->pict_type = AV_PICTURE_TYPE_I;
+
+    *got_frame   = 1;
+
+    return buf_size;
+}
+
+const FFCodec ff_wbmp_decoder = {
+    .p.name         = "wbmp",
+    .p.long_name    = NULL_IF_CONFIG_SMALL("WBMP (Wireless Application Protocol Bitmap) image"),
+    .p.type         = AVMEDIA_TYPE_VIDEO,
+    .p.id           = AV_CODEC_ID_WBMP,
+    .p.capabilities = AV_CODEC_CAP_DR1 | AV_CODEC_CAP_FRAME_THREADS,
+    FF_CODEC_DECODE_CB(wbmp_decode_frame),
+};
diff --git a/libavcodec/wbmpenc.c b/libavcodec/wbmpenc.c
new file mode 100644
index 0000000000..c2dd5f5ca9
--- /dev/null
+++ b/libavcodec/wbmpenc.c
@@ -0,0 +1,89 @@
+/*
+ * WBMP (Wireless Application Protocol Bitmap) image
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "avcodec.h"
+#include "bytestream.h"
+#include "codec_internal.h"
+#include "encode.h"
+
+static void putv(uint8_t ** bufp, unsigned int v)
+{
+    unsigned int vv = 0;
+    int n = 0;
+
+    while (vv != v)
+        vv += v & (0x7F << 7 * n++);
+
+    while (--n > 0)
+        bytestream_put_byte(bufp, 0x80 | (v & (0x7F << 7 * n)) >> 7 * n);
+
+    bytestream_put_byte(bufp, v & 0x7F);
+}
+
+static void writebits(uint8_t ** bufp, const uint8_t * src, int width, int height, int linesize)
+{
+    int wpad = (width + 7) / 8;
+    for (int j = 0; j < height; j++) {
+        memcpy(*bufp, src, wpad);
+        *bufp += wpad;
+        src += linesize;
+    }
+}
+
+static int wbmp_encode_frame(AVCodecContext *avctx, AVPacket *pkt,
+                            const AVFrame *frame, int *got_packet)
+{
+    int64_t size = avctx->height * ((avctx->width + 7) / 8) + 32;
+    uint8_t *buf;
+    int ret;
+
+    if ((ret = ff_get_encode_buffer(avctx, pkt, size, 0)) < 0)
+        return ret;
+
+    buf = pkt->data;
+
+    putv(&buf, 0);
+    bytestream_put_byte(&buf, 0);
+    putv(&buf, avctx->width);
+    putv(&buf, avctx->height);
+
+    if (frame->linesize[0] == (avctx->width + 7) / 8)
+        bytestream_put_buffer(&buf, frame->data[0], avctx->height * ((avctx->width + 7) / 8));
+    else
+        writebits(&buf, frame->data[0], avctx->width, avctx->height, frame->linesize[0]);
+
+    av_shrink_packet(pkt, buf - pkt->data);
+
+    *got_packet = 1;
+    return 0;
+}
+
+const FFCodec ff_wbmp_encoder = {
+    .p.name         = "wbmp",
+    .p.long_name    = NULL_IF_CONFIG_SMALL("WBMP (Wireless Application Protocol Bitmap) image"),
+    .p.type         = AVMEDIA_TYPE_VIDEO,
+    .p.id           = AV_CODEC_ID_WBMP,
+    .p.capabilities = AV_CODEC_CAP_DR1 | AV_CODEC_CAP_FRAME_THREADS,
+    FF_CODEC_ENCODE_CB(wbmp_encode_frame),
+    .p.pix_fmts     = (const enum AVPixelFormat[]){
+        AV_PIX_FMT_MONOBLACK,
+        AV_PIX_FMT_NONE
+    },
+};
diff --git a/libavformat/img2.c b/libavformat/img2.c
index 233e83de37..06e48549ac 100644
--- a/libavformat/img2.c
+++ b/libavformat/img2.c
@@ -92,6 +92,7 @@ const IdStrMap ff_img_tags[] = {
     { AV_CODEC_ID_JPEGXL,     "jxl"      },
     { AV_CODEC_ID_QOI,        "qoi"      },
     { AV_CODEC_ID_RADIANCE_HDR, "hdr"    },
+    { AV_CODEC_ID_WBMP,       "wbmp"     },
     { AV_CODEC_ID_NONE,       NULL       }
 };
 
diff --git a/libavformat/img2enc.c b/libavformat/img2enc.c
index 40dc51b443..c05f37e22b 100644
--- a/libavformat/img2enc.c
+++ b/libavformat/img2enc.c
@@ -273,7 +273,7 @@ const AVOutputFormat ff_image2_muxer = {
     .long_name      = NULL_IF_CONFIG_SMALL("image2 sequence"),
     .extensions     = "bmp,dpx,exr,jls,jpeg,jpg,jxl,ljpg,pam,pbm,pcx,pfm,pgm,pgmyuv,phm,"
                       "png,ppm,sgi,tga,tif,tiff,jp2,j2c,j2k,xwd,sun,ras,rs,im1,im8,"
-                      "im24,sunras,vbn,xbm,xface,pix,y,avif,qoi,hdr",
+                      "im24,sunras,vbn,xbm,xface,pix,y,avif,qoi,hdr,wbmp",
     .priv_data_size = sizeof(VideoMuxData),
     .video_codec    = AV_CODEC_ID_MJPEG,
     .write_header   = write_header,
diff --git a/tests/fate/lavf-image.mak b/tests/fate/lavf-image.mak
index 38d3689abf..130a199127 100644
--- a/tests/fate/lavf-image.mak
+++ b/tests/fate/lavf-image.mak
@@ -43,6 +43,7 @@ FATE_LAVF_IMAGES-$(call LAVF_IMAGES,     SUNRAST) += sun
 FATE_LAVF_IMAGES-$(call LAVF_IMAGES,       TARGA) += tga
 FATE_LAVF_IMAGES-$(call LAVF_IMAGES,        TIFF) += tiff
 FATE_LAVF_IMAGES-$(call LAVF_IMAGES,         QOI) += qoi
+FATE_LAVF_IMAGES-$(call LAVF_IMAGES,        WBMP) += wbmp
 FATE_LAVF_IMAGES-$(call LAVF_IMAGES,         XBM) += xbm
 FATE_LAVF_IMAGES-$(call LAVF_IMAGES,         XWD) += xwd
 FATE_LAVF_IMAGES-$(call LAVF_IMAGES,         XWD) += rgba.xwd
diff --git a/tests/ref/lavf/wbmp b/tests/ref/lavf/wbmp
new file mode 100644
index 0000000000..9b4b2767f6
--- /dev/null
+++ b/tests/ref/lavf/wbmp
@@ -0,0 +1,3 @@
+ebe2a887bd3098ac50502063257b4275 *tests/data/images/wbmp/02.wbmp
+tests/data/images/wbmp/%02d.wbmp CRC=0xab19200d
+12678 tests/data/images/wbmp/02.wbmp